/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the OrganizationPermissions type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OrganizationPermissions{}

// OrganizationPermissions struct for OrganizationPermissions
type OrganizationPermissions struct {
	// Context dependant, not always available
	Id *string `json:"id,omitempty"`
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	ObjectPermission int32 `json:"object_permission"`
	Channels []ChannelPermission `json:"channels,omitempty"`
	Permissions *OrganizationPermissionsPermissions `json:"permissions,omitempty"`
	Permission Permission `json:"permission"`
}

// NewOrganizationPermissions instantiates a new OrganizationPermissions object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOrganizationPermissions(objectPermission int32, permission Permission) *OrganizationPermissions {
	this := OrganizationPermissions{}
	this.ObjectPermission = objectPermission
	this.Permission = permission
	return &this
}

// NewOrganizationPermissionsWithDefaults instantiates a new OrganizationPermissions object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOrganizationPermissionsWithDefaults() *OrganizationPermissions {
	this := OrganizationPermissions{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *OrganizationPermissions) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationPermissions) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *OrganizationPermissions) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *OrganizationPermissions) SetId(v string) {
	o.Id = &v
}

// GetObjectPermission returns the ObjectPermission field value
func (o *OrganizationPermissions) GetObjectPermission() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.ObjectPermission
}

// GetObjectPermissionOk returns a tuple with the ObjectPermission field value
// and a boolean to check if the value has been set.
func (o *OrganizationPermissions) GetObjectPermissionOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ObjectPermission, true
}

// SetObjectPermission sets field value
func (o *OrganizationPermissions) SetObjectPermission(v int32) {
	o.ObjectPermission = v
}

// GetChannels returns the Channels field value if set, zero value otherwise.
func (o *OrganizationPermissions) GetChannels() []ChannelPermission {
	if o == nil || IsNil(o.Channels) {
		var ret []ChannelPermission
		return ret
	}
	return o.Channels
}

// GetChannelsOk returns a tuple with the Channels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationPermissions) GetChannelsOk() ([]ChannelPermission, bool) {
	if o == nil || IsNil(o.Channels) {
		return nil, false
	}
	return o.Channels, true
}

// HasChannels returns a boolean if a field has been set.
func (o *OrganizationPermissions) HasChannels() bool {
	if o != nil && !IsNil(o.Channels) {
		return true
	}

	return false
}

// SetChannels gets a reference to the given []ChannelPermission and assigns it to the Channels field.
func (o *OrganizationPermissions) SetChannels(v []ChannelPermission) {
	o.Channels = v
}

// GetPermissions returns the Permissions field value if set, zero value otherwise.
func (o *OrganizationPermissions) GetPermissions() OrganizationPermissionsPermissions {
	if o == nil || IsNil(o.Permissions) {
		var ret OrganizationPermissionsPermissions
		return ret
	}
	return *o.Permissions
}

// GetPermissionsOk returns a tuple with the Permissions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationPermissions) GetPermissionsOk() (*OrganizationPermissionsPermissions, bool) {
	if o == nil || IsNil(o.Permissions) {
		return nil, false
	}
	return o.Permissions, true
}

// HasPermissions returns a boolean if a field has been set.
func (o *OrganizationPermissions) HasPermissions() bool {
	if o != nil && !IsNil(o.Permissions) {
		return true
	}

	return false
}

// SetPermissions gets a reference to the given OrganizationPermissionsPermissions and assigns it to the Permissions field.
func (o *OrganizationPermissions) SetPermissions(v OrganizationPermissionsPermissions) {
	o.Permissions = &v
}

// GetPermission returns the Permission field value
func (o *OrganizationPermissions) GetPermission() Permission {
	if o == nil {
		var ret Permission
		return ret
	}

	return o.Permission
}

// GetPermissionOk returns a tuple with the Permission field value
// and a boolean to check if the value has been set.
func (o *OrganizationPermissions) GetPermissionOk() (*Permission, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Permission, true
}

// SetPermission sets field value
func (o *OrganizationPermissions) SetPermission(v Permission) {
	o.Permission = v
}

func (o OrganizationPermissions) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OrganizationPermissions) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	toSerialize["object_permission"] = o.ObjectPermission
	if !IsNil(o.Channels) {
		toSerialize["channels"] = o.Channels
	}
	if !IsNil(o.Permissions) {
		toSerialize["permissions"] = o.Permissions
	}
	toSerialize["permission"] = o.Permission
	return toSerialize, nil
}

type NullableOrganizationPermissions struct {
	value *OrganizationPermissions
	isSet bool
}

func (v NullableOrganizationPermissions) Get() *OrganizationPermissions {
	return v.value
}

func (v *NullableOrganizationPermissions) Set(val *OrganizationPermissions) {
	v.value = val
	v.isSet = true
}

func (v NullableOrganizationPermissions) IsSet() bool {
	return v.isSet
}

func (v *NullableOrganizationPermissions) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOrganizationPermissions(val *OrganizationPermissions) *NullableOrganizationPermissions {
	return &NullableOrganizationPermissions{value: val, isSet: true}
}

func (v NullableOrganizationPermissions) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOrganizationPermissions) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


